"use client";
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/autocomplete.tsx
var autocomplete_exports = {};
__export(autocomplete_exports, {
  Autocomplete: () => Autocomplete,
  useStylesContext: () => useStylesContext
});
module.exports = __toCommonJS(autocomplete_exports);
var Popper = __toESM(require("@webbo-ui/popper"));
var import_use_controllable_state = require("@webbo-ui/use-controllable-state");
var import_error = require("@webbo-ui/error");

// src/option.tsx
var import_react_utils = require("@webbo-ui/react-utils");
var import_use_pointer_events = require("@webbo-ui/use-pointer-events");
var import_react = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var Option_Name = "Option";
var Option = import_react.default.forwardRef(
  (props, ref) => {
    const {
      onSelect,
      onHover,
      state: { disabled, focused, selected },
      children,
      id,
      className
    } = props;
    const styles = useStylesContext(Option_Name);
    const innerRef = import_react.default.useRef(null);
    const isHovered = import_react.default.useRef(false);
    const pointerEvents = (0, import_use_pointer_events.usePointerEvents)({
      onPress: () => {
        if (disabled)
          return;
        onSelect();
      }
    });
    import_react.default.useEffect(() => {
      if (selected)
        innerRef.current?.scrollIntoView({
          behavior: "instant",
          block: "center"
        });
    }, [selected]);
    import_react.default.useEffect(() => {
      if (focused && !isHovered.current)
        innerRef.current?.scrollIntoView({
          behavior: "instant",
          block: "nearest"
        });
    }, [focused]);
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "li",
      {
        ref: (0, import_react_utils.mergeRefs)(ref, innerRef),
        onPointerEnter: () => {
          isHovered.current = true;
          onHover();
        },
        onPointerLeave: () => {
          isHovered.current = false;
        },
        className: styles.option({ className }),
        id,
        role: "option",
        "aria-selected": disabled ? void 0 : selected,
        "data-disabled": disabled,
        "data-selected": selected,
        "data-focused": focused,
        ...pointerEvents,
        children
      }
    );
  }
);
Option.displayName = "webbo-ui." + Option_Name;

// src/autocomplete.tsx
var import_lodash = __toESM(require("lodash.groupby"));
var import_theme = require("@webbo-ui/theme");
var import_react_utils2 = require("@webbo-ui/react-utils");
var import_react2 = __toESM(require("react"));
var import_react_dom = require("react-dom");
var import_context = require("@webbo-ui/context");
var import_jsx_runtime2 = require("react/jsx-runtime");
var import_react3 = require("react");
var Autocomplete_Name = "Autocomplete";
var [StylesProvider, stylesHook] = (0, import_context.createContextScope)(Autocomplete_Name);
var useStylesContext = stylesHook;
var AutocompleteImp = import_react2.default.forwardRef((props, ref) => {
  const {
    classNames,
    className,
    offset,
    isOpen: openProp,
    onOpenChange,
    defaultOpen = false,
    defaultValue,
    value: valueProp,
    onChange,
    shadow = "md",
    options: optionsProp = [],
    disabled,
    multiple,
    disableClearable,
    disableCloseOnSelect,
    getOptionDisabled,
    noOptionsText = "no options",
    loading,
    loadingText = "loading ...",
    getOptionLabel: getOptionLabelProp,
    getOptionKey,
    groupBy,
    inputValue: inputValueProp,
    onInputChange: onInputChangeProp,
    filterOptions,
    renderInput,
    disablePortal,
    disablePopper,
    renderOption,
    ...restProps
  } = props;
  const getOptionLabel = (option) => {
    if (loading)
      return "";
    if (getOptionLabelProp) {
      return getOptionLabelProp(option);
    }
    if (!("label" in option))
      throw new import_error.CustomError(
        "Select",
        "consider to add `label` property in all options or use `getOptionLabel` prop to get option label"
      );
    return option.label;
  };
  const [value, setValue] = (0, import_use_controllable_state.useControllableState)({
    defaultValue,
    value: valueProp,
    onChange: (value2, reason) => {
      if (!reason)
        throw new import_error.CustomError(
          "Autocomplete",
          "internal Error, reason is not defined"
        );
      onChange?.({ target: { value: value2 } }, reason, value2);
    }
  });
  const inputDefaultValue = !Array.isArray(value) && value ? getOptionLabel(value) : "";
  const prevSelectedValue = import_react2.default.useRef(inputDefaultValue);
  const [inputValue, setInputValue] = (0, import_use_controllable_state.useControllableState)({
    defaultValue: inputDefaultValue,
    value: inputValueProp,
    onChange: onInputChangeProp
  });
  const [options, setOptions] = import_react2.default.useState(optionsProp);
  const groupedOptions = import_react2.default.useMemo(() => {
    if (!groupBy)
      return null;
    const grouped = (0, import_lodash.default)(options, (opt) => {
      const by = groupBy(opt);
      if (!isNaN(+by))
        return "0-9";
      return by;
    });
    return Object.entries(grouped).sort((a, b) => {
      const a_key = a[0];
      const b_key = b[0];
      if (a_key < b_key)
        return -1;
      if (a_key > b_key)
        return 1;
      return 0;
    }).reduce(
      (acc, ele) => (acc[ele[0]] = ele[1], acc),
      {}
    );
  }, [groupBy, options]);
  const inputRef = import_react2.default.useRef(null);
  const popperReferenceRef = import_react2.default.useRef(null);
  const [focused, setFocused] = import_react2.default.useState(null);
  const lisboxId = import_react2.default.useId();
  const [isOpen, setIsOpen] = (0, import_use_controllable_state.useControllableState)({
    defaultValue: defaultOpen ?? false,
    value: openProp,
    onChange: onOpenChange
  });
  const handleClose = () => {
    setIsOpen(false);
    setFocused(null);
    setOptions(optionsProp);
    if (Array.isArray(value))
      setInputValue("");
    if (prevSelectedValue.current !== inputValue)
      setInputValue(prevSelectedValue.current);
  };
  const onOpen = () => {
    if (isOpen)
      return;
    setIsOpen(true);
    if (!options.length)
      return;
    if (!value) {
      setFocused(getNext(options[0], options, getOptionDisabled));
      return;
    }
    setFocused(Array.isArray(value) ? value[0] : value);
  };
  const onSelect = (option) => {
    if (Array.isArray(value)) {
      const val = value.find((ele) => ele === option) ? value.filter((ele) => ele !== option) : [...value, option];
      setValue(val, "select");
      setFocused(option);
      setInputValue("");
    }
    if (!Array.isArray(value)) {
      setValue(option, "select");
      setFocused(option);
      const val = getOptionLabel(option);
      setInputValue(val);
      prevSelectedValue.current = val;
    }
    if (!disableCloseOnSelect)
      handleClose();
    setOptions(optionsProp);
  };
  const onHover = (option) => {
    setFocused(option);
  };
  const handleKeyDown = (e) => {
    const ArrowDown = e.key === "ArrowDown";
    const ArrowUp = e.key === "ArrowUp";
    const Escape = e.key === "Escape";
    const Enter = e.key === "Enter";
    const Home = e.key === "Home";
    const End = e.key === "End";
    if (ArrowDown || ArrowUp)
      e.preventDefault();
    if (ArrowDown && !isOpen) {
      onOpen();
      return;
    }
    if (!options.length || !isOpen)
      return;
    if (Escape) {
      handleClose();
      return;
    }
    if (Enter && focused) {
      e.preventDefault();
      onSelect(focused);
      return;
    }
    if ((ArrowDown || ArrowUp) && !focused) {
      setFocused(getNext(options[0], options, getOptionDisabled));
      return;
    }
    if (ArrowDown && focused && focused !== options[options.length - 1]) {
      setFocused(getNext(options[options.indexOf(focused) + 1], options));
      return;
    }
    if (ArrowUp && focused && focused !== options[0]) {
      setFocused(getPrevious(options[options.indexOf(focused) - 1], options));
      return;
    }
    if (Home) {
      setFocused(getNext(options[0], options));
      return;
    }
    if (End) {
      setFocused(getPrevious(options[options.length - 1], options));
      return;
    }
  };
  const onClear = () => {
    inputRef.current?.focus();
    setFocused(null);
    setInputValue("");
    prevSelectedValue.current = "";
    setOptions(optionsProp);
    if (multiple) {
      setValue([], "clear");
    } else {
      setValue(null, "clear");
    }
  };
  const handleInputChange = (e) => {
    if (loading)
      return;
    const val = e.target.value;
    setInputValue(val);
    setIsOpen(true);
    if (!val) {
      setOptions(optionsProp);
      setFocused(null);
      return;
    }
    const filter = filterOptions || ((options2, inputValue2) => options2.filter(
      (opt) => getOptionLabel(opt).toLowerCase().startsWith(inputValue2.toLowerCase())
    ));
    setOptions(filter(optionsProp, val));
  };
  const getOptionId = (ele) => getOptionKey?.(ele) ?? getOptionLabel(ele).replaceAll(" ", "-");
  const styles = import_react2.default.useMemo(() => (0, import_theme.autocomplete)({ shadow }), [shadow]);
  const getOptionProps = (ele) => ({
    key: getOptionId(ele),
    option: ele,
    onHover: () => onHover(ele),
    onSelect: () => onSelect(ele),
    id: getOptionId(ele),
    className: styles.option({ className: classNames?.option }),
    state: {
      focused: ele === focused,
      selected: Array.isArray(value) ? !!value.find((val) => val === ele) : ele === value,
      disabled: getOptionDisabled?.(ele) ?? false
    }
  });
  if (multiple && !Array.isArray(value))
    throw new import_error.CustomError(
      "Autocomplete",
      "value must be an Array when multiple is true"
    );
  if (!multiple && Array.isArray(value))
    throw new import_error.CustomError(
      "Autocomplete",
      "value must not be an Array when multiple is false"
    );
  if (!renderInput)
    throw new import_error.CustomError("Autocomplete", "`renderInput` prop is required");
  const listBox = /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
    "ul",
    {
      ...restProps,
      ref,
      id: lisboxId,
      className: styles.listbox({
        className: classNames?.listbox ?? className
      }),
      role: "listbox",
      "aria-multiselectable": multiple,
      "aria-roledescription": multiple ? "multiple select list" : "single select list",
      onPointerDown: (e) => e.preventDefault(),
      children: [
        !loading && options.length && !groupBy ? options.map((option) => {
          const label = getOptionLabel(option);
          const props2 = getOptionProps(option);
          return /* @__PURE__ */ (0, import_react3.createElement)(Option, { ...props2, key: props2.key }, renderOption?.({
            option,
            label,
            state: props2.state
          }) ?? label);
        }) : null,
        !loading && options.length && groupBy && groupedOptions ? Object.entries(groupedOptions).map(([groupHeader, grouped]) => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(
          "li",
          {
            className: styles.group({
              className: classNames?.group
            }),
            children: [
              /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "div",
                {
                  className: styles.groupHeader({
                    className: classNames?.groupHeader
                  }),
                  children: groupHeader
                }
              ),
              /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
                "ul",
                {
                  className: styles.groupItems({
                    className: classNames?.groupItems
                  }),
                  children: grouped.map((option) => {
                    const label = getOptionLabel(option);
                    const props2 = getOptionProps(option);
                    return /* @__PURE__ */ (0, import_react3.createElement)(Option, { ...props2, key: props2.key }, renderOption?.({
                      option,
                      label,
                      state: props2.state
                    }) ?? label);
                  })
                }
              )
            ]
          },
          groupHeader.replaceAll(" ", "-")
        )) : null,
        !loading && !options?.length ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "div",
          {
            className: styles.noOptions({
              className: classNames?.noOptions
            }),
            children: noOptionsText
          }
        ) : null,
        loading ? /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
          "div",
          {
            className: styles.loading({
              className: classNames?.noOptions
            }),
            children: loadingText
          }
        ) : null
      ]
    }
  );
  const withPopper = disablePopper ? listBox : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Popper.Floating, { sticky: "always", mainOffset: offset || 5, children: listBox });
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(Popper.Root, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Popper.Reference, { children: ({ referenceRef }) => renderInput({
      selected: Array.isArray(value) ? value.map((opt) => ({
        label: getOptionLabel(opt),
        onDelete: () => {
          setValue(
            (prev) => Array.isArray(prev) ? prev.filter((ele) => ele !== opt) : null,
            "remove"
          );
        }
      })) : null,
      onBlur: handleClose,
      isOpen,
      multiple: !!multiple,
      onOpen,
      clearButtonProps: {
        onClear,
        onPointerDown: (e) => e.preventDefault(),
        tabIndex: -1,
        "aria-label": "clear value button"
      },
      showClearButton: disableClearable ? false : Array.isArray(value) ? !!value.length : !!value,
      popperReferenceRef: (0, import_react_utils2.mergeRefs)(referenceRef, popperReferenceRef),
      inputRef,
      inputValue,
      onChange: handleInputChange,
      disabled: !!disabled,
      onKeyDown: handleKeyDown,
      loading: !!loading,
      ariaProps: {
        role: "combobox",
        "aria-expanded": isOpen,
        "aria-controls": lisboxId,
        "aria-haspopup": "listbox",
        "aria-autocomplete": "list",
        "aria-activedescendant": isOpen && focused ? getOptionId(focused) : void 0
      }
    }) }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(StylesProvider, { ...styles, children: isOpen ? disablePortal ? withPopper : (0, import_react_dom.createPortal)(withPopper, document.body) : null })
  ] });
});
AutocompleteImp.displayName = "webbo-ui." + Autocomplete_Name;
var Autocomplete = AutocompleteImp;
var getNext = (current, items, isOptionDisabled) => {
  if (!isOptionDisabled)
    return current;
  for (let i = items.indexOf(current); i <= items.length; i++) {
    const option = items[i];
    if (!isOptionDisabled(option))
      return option;
  }
  return current;
};
var getPrevious = (current, items, isOptionDisabled) => {
  if (!isOptionDisabled)
    return current;
  for (let i = items.indexOf(current) - 1; i > 0; i--) {
    const option = items[i];
    if (!isOptionDisabled(option))
      return option;
  }
  return current;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Autocomplete,
  useStylesContext
});
