import * as React from 'react';
import * as _webbo_ui_theme from '@webbo-ui/theme';
import { RenderInputProps, Reason } from './autocomplete.js';
export { AutocompleteProps } from './autocomplete.js';
export { mapInputProps } from './map-input-props.js';
import '@webbo-ui/popper';
import '@webbo-ui/input';

declare const Autocomplete: <Value extends object, Multiple extends boolean = false, DisableClearable extends boolean = false>(props: _webbo_ui_theme.AutocompleteVariantProps & Omit<React.HTMLAttributes<HTMLUListElement>, "children" | "onChange" | "defaultValue"> & {
    disabled?: boolean | undefined;
    classNames?: _webbo_ui_theme.ClassNames<{
        listbox: string;
        option: string;
        noOptions: string;
        loading: string;
        group: string;
        groupHeader: string;
        groupItems: string;
    }> | undefined;
    offset?: number | undefined;
    options: Value[];
    isOpen?: boolean | undefined;
    onOpenChange?: ((open: boolean) => void) | undefined;
    defaultOpen?: boolean | undefined;
    getOptionDisabled?: ((option: Value) => boolean) | undefined;
    disableCloseOnSelect?: boolean | undefined;
    getOptionLabel?: ((option: Value) => string) | undefined;
    getOptionKey?: ((options: Value) => string) | undefined;
    noOptionsText?: string | undefined;
    loading?: boolean | undefined;
    loadingText?: string | undefined;
    groupBy?: ((option: Value) => string) | undefined;
    inputValue?: string | undefined;
    onInputChange?: ((val: string) => void) | undefined;
    filterOptions?: ((options: Value[], inputValue: string) => Value[]) | undefined;
    disablePortal?: boolean | undefined;
    disablePopper?: boolean | undefined;
    renderInput: (props: RenderInputProps) => React.ReactNode;
    renderOption?: ((props: {
        option: Value;
        label: string;
        state: {
            disabled: boolean;
            selected: boolean;
            focused: boolean;
        };
    }) => React.ReactNode) | undefined;
} & (Multiple extends true ? {
    multiple: Multiple;
    defaultValue?: Value[] | undefined;
    value?: Value[] | undefined;
    onChange?: ((event: {
        target: {
            value: Value[];
        };
    }, reason: Reason, value: Value[]) => void) | undefined;
    disableClearable?: DisableClearable | undefined;
} : DisableClearable extends true ? {
    multiple?: Multiple | undefined;
    defaultValue?: Value | undefined;
    value?: Value | undefined;
    onChange?: ((event: {
        target: {
            value: Value;
        };
    }, reason: Reason, value: Value) => void) | undefined;
    disableClearable: DisableClearable;
} : {
    multiple?: Multiple | undefined;
    defaultValue?: Value | undefined;
    value?: Value | null | undefined;
    onChange?: ((event: {
        target: {
            value: Value | null;
        };
    }, reason: Reason, value: Value | null) => void) | undefined;
    disableClearable?: DisableClearable | undefined;
}) & React.RefAttributes<HTMLUListElement>) => React.ReactNode;

export { Autocomplete, Reason };
